unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  Spin, ExProgressbar;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ColorButton1: TColorButton;
    ColorButton2: TColorButton;
    ColorButton3: TColorButton;
    ColorButton4: TColorButton;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    FontDialog1: TFontDialog;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ProgressBar1: TProgressBar;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    ScrollBar1: TScrollBar;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure ColorButton1ColorChanged(Sender: TObject);
    procedure ColorButton2ColorChanged(Sender: TObject);
    procedure ColorButton3ColorChanged(Sender: TObject);
    procedure ColorButton4ColorChanged(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioButton1Change(Sender: TObject);
    procedure RadioButton2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
  private
    ProgressbarEx: TProgressbarEx;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  ProgressbarEx := TProgressbarEx.Create(self);
  ProgressbarEx.Left := 8;
  ProgressbarEx.Top := 8;
  ProgressbarEx.Width := 300;
  ProgressbarEx.Parent := self;
  Progressbarex.Position := 50;

  ColorButton1.ButtonColor := ProgressbarEx.BackColor;
  ColorButton2.ButtonColor := ProgressbarEx.BarColor1;
  ColorButton3.ButtonColor := ProgressbarEx.BarColor2;
  ColorButton4.ButtonColor := ProgressbarEx.BorderColor;

  Scrollbar1.Position := ProgressbarEx.Position;
  Edit1.Hide;
end;

procedure TForm1.RadioButton1Change(Sender: TObject);
begin
  Progressbar1.style := pbstNormal;
  ProgressbarEx.Style := pbstNormal;
  ProgressbarEx.Caption := IntToStr(ProgressbarEx.Position);
  Scrollbar1.Position := ProgressbarEx.Position;
  Scrollbar1.Show;
  Edit1.Hide;
end;

procedure TForm1.RadioButton2Change(Sender: TObject);
begin
  Progressbar1.Style := pbstMarquee;
  ProgressbarEx.Style := pbstMarquee;
  ProgressbarEx.Caption := Edit1.Text;
  Scrollbar1.Hide;
  Edit1.Show;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  ProgressbarEx.Caption := Edit1.Text;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FontDialog1.Font := ProgressbarEx.Font;
  if FontDialog1.Execute then
    ProgressbarEx.Font := FontDialog1.Font;
end;

procedure TForm1.ColorButton1ColorChanged(Sender: TObject);
begin
  ProgressbarEx.BackColor := ColorButton1.ButtonColor;
end;

procedure TForm1.ColorButton2ColorChanged(Sender: TObject);
begin
  ProgressbarEx.BarColor1 := ColorButton2.ButtonColor;
end;

procedure TForm1.ColorButton3ColorChanged(Sender: TObject);
begin
  ProgressbarEx.BarColor2 := ColorButton3.ButtonColor;
end;

procedure TForm1.ColorButton4ColorChanged(Sender: TObject);
begin
  ProgressbarEx.BorderColor := ColorButton4.ButtonColor;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  ProgressbarEx.Orientation := TProgressbarOrientation(Combobox1.ItemIndex);

  Progressbar1.Orientation := ProgressBarEx.Orientation;
  if Progressbar1.Orientation in [pbVertical, pbTopDown] then
  begin
    Progressbar1.Left := 32;
    Progressbar1.Top := 8;
  end else
  begin
    Progressbar1.Left := 8;
    Progressbar1.Top := 32;
  end;
  Progressbar1.Width := ProgressbarEx.Width;
  Progressbar1.Height := ProgressbarEx.Height;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  ProgressbarEx.Position := Scrollbar1.Position;
  ProgressbarEx.Caption := IntToStr(Scrollbar1.Position);

  Progressbar1.Position := Scrollbar1.Position;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  ProgressbarEx.MarqueeLength := SpinEdit1.Value;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  ProgressbarEx.MarqueeSpeed := SpinEdit2.Value;
end;

end.

